<?php

	// ---------------------------------------- //
	// ---------------------------------------- //
	// ------- Автор: wh0am1 ------------------ //
	// ------- ICQ: 33232422 ------------------ //
	// ------- Skype: r79954119859 ------------ //
	// ---------------------------------------- //
	// ---------------------------------------- //
	
	$starttime = microtime ( TRUE ) ;

	require_once('protected/utils.php');

	$routes = require_once('protected/routes.php');

	$uri = parse_url ( $_SERVER [ 'REQUEST_URI' ], PHP_URL_PATH );

	$args = array();

	$app = FALSE;
	$layout = FALSE;

	foreach ( $routes as $map ) {
		if ( preg_match ( $map [ 'pattern' ], $uri, $matches ) ) {
			array_shift ( $matches ) ;

			foreach ( $matches as $index => $value ) {
				$args [ $map [ 'args' ] [ $index ] ] = $value;
			}

			$app = $map [ 'app' ] ;
			$layout= $map [ 'layout' ] ;

			break;
		}
	}

	if ( $app == FALSE AND $layout == FALSE ) {
		header ( 'Location: /?' ) ;
		exit;
	}

	if ( isset ( $args [ 'key' ] ) ) {

		$key = $args [ 'key' ];

		if ( empty ( $key ) ) {
			print ( 'Not found key...' ) ;
			exit;
		}

		if ( !isset_code ( $key ) ) {
			print ( 'Not found code...' ) ;
			exit;
		}

	}

	if ( $app != FALSE ) {
		if ( file_exists ( 'app/' . $app ) ) {
			require_once ( 'app/' . $app );
		}
		else {
			print ( 'App ' . $app . ' not found...' ) ;
		}
	}

	if ( $layout != FALSE ) {
		if ( file_exists ( 'layout/' . $layout ) ) {
			require_once ( 'layout/' . $layout );
		}
		else {
			print ( 'Layout ' . $layout . ' not found...' ) ;
		}
	}

?>